pub mod arena;
pub mod node;

use crate::state::GameState;
use crate::tree::arena::Arena;
use crate::tree::node::Node;

pub fn print_tree<S: GameState>(node_id: usize, arena: &Arena<S>) {
    let mut to_print: Vec<usize> = Vec::new();
    to_print.push(node_id);
    while let Some(node_id) = to_print.pop() {
        let node: &Node<S> = arena.get_node(node_id);
        if node.depth > 0 {
            for _ in 0..node.depth - 1 {
                print!("|  ")
            }
            print!("|- ");
        }
        println!(
            "{:?} a:{:?} v:{}  {:?}",
            node_id, node.action, node.visits, node.player_view
        );
        for child_id in node.children.iter().rev() {
            to_print.push(*child_id);
        }
    }
}
